Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.cs	(revision 3392)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.cs	(revision 3394)
@@ -36,8 +36,11 @@
       InitializeComponent();
     }
-
     public DockingMainForm(Type userInterfaceItemType)
       : base(userInterfaceItemType) {
       InitializeComponent();
+    }
+    public DockingMainForm(Type userInterfaceItemType, bool showInViewHost)
+      : this(userInterfaceItemType) {
+      this.ShowInViewHost = showInViewHost;
     }
 
@@ -64,5 +67,12 @@
 
     protected override Form CreateForm(IView view) {
-      return new DockForm(view);
+      DockForm form;
+      IContentView contentView = view as IContentView;
+      if (ShowInViewHost && contentView != null && contentView.GetType() != typeof(ViewHost)) {
+        ViewHost viewHost = new ViewHost(contentView.Content);
+        form = new DockForm(viewHost);
+      } else
+        form = new DockForm(view);
+      return form;
     }
 
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainForm.cs	(revision 3392)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainForm.cs	(revision 3394)
@@ -51,4 +51,10 @@
 
     #region properties
+    private bool showInViewHost;
+    public bool ShowInViewHost {
+      get { return this.showInViewHost; }
+      set { this.showInViewHost = value; }
+    }
+
     public string Title {
       get { return this.Text; }
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MultipleDocumentMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MultipleDocumentMainForm.cs	(revision 3392)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MultipleDocumentMainForm.cs	(revision 3394)
@@ -35,8 +35,11 @@
       InitializeComponent();
     }
-
     public MultipleDocumentMainForm(Type userInterfaceType)
       : base(userInterfaceType) {
       InitializeComponent();
+    }
+    public MultipleDocumentMainForm(Type userInterfaceItemType, bool showInViewHost)
+      : this(userInterfaceItemType) {
+      this.ShowInViewHost = showInViewHost;
     }
 
@@ -70,5 +73,12 @@
 
     protected override Form CreateForm(IView view) {
-      Form form = new DocumentForm(view);
+      Form form;
+      IContentView contentView = view as IContentView;
+      if (ShowInViewHost && contentView != null && contentView.GetType() != typeof(ViewHost)) {
+        ViewHost viewHost = new ViewHost(contentView.Content);
+        form = new DocumentForm(viewHost);
+      } else
+        form = new DocumentForm(view);
+
       form.MdiParent = this;
       return form;
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/SingleDocumentMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/SingleDocumentMainForm.cs	(revision 3392)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/SingleDocumentMainForm.cs	(revision 3394)
@@ -36,8 +36,11 @@
       InitializeComponent();
     }
-
     public SingleDocumentMainForm(Type userInterfaceItemType)
       : base(userInterfaceItemType) {
       InitializeComponent();
+    }
+    public SingleDocumentMainForm(Type userInterfaceItemType, bool showInViewHost)
+      : this(userInterfaceItemType) {
+      this.ShowInViewHost = showInViewHost;
     }
 
@@ -64,5 +67,12 @@
 
     protected override Form CreateForm(IView view) {
-      DocumentForm form = new DocumentForm(view);
+      Form form;
+      IContentView contentView = view as IContentView;
+      if (ShowInViewHost && contentView != null && contentView.GetType() != typeof(ViewHost)) {
+        ViewHost viewHost = new ViewHost(contentView.Content);
+        form = new DocumentForm(viewHost);
+      } else
+        form = new DocumentForm(view);
+
       form.ShowInTaskbar = true;
       return form;
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ViewHost.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ViewHost.cs	(revision 3392)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ViewHost.cs	(revision 3394)
@@ -130,4 +130,6 @@
         cachedViews.Add(viewType, view);
       }
+      this.Caption = view.Caption;
+      this.SaveEnabled = view.SaveEnabled;
 
       Control control = (Control)view;