Index: trunk/sources/HeuristicLab.Core.Views/3.3/OperatorGraphView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/OperatorGraphView.cs	(revision 3394)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/OperatorGraphView.cs	(revision 3395)
@@ -30,5 +30,5 @@
   /// The visual representation of an <see cref="OperatorGraph"/>.
   /// </summary>
-  [View("OperatorGraph View (Tree)",ShowInViewHost=true)]
+  [View("OperatorGraph View (Tree)")]
   [Content(typeof(OperatorGraph), false)]
   public partial class OperatorGraphView : ItemView {
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockForm.cs	(revision 3394)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockForm.cs	(revision 3395)
@@ -58,14 +58,5 @@
           this.view.CaptionChanged += new EventHandler(View_CaptionChanged);
           UpdateText();
-
-          ContentView contentView = view as ContentView;
-          if (ViewAttribute.GetShowInViewHost(viewType) && contentView != null) {
-            ViewHost viewHost = new ViewHost();
-            viewHost.ViewType = viewType;
-            viewHost.Content = contentView.Content;
-            viewHost.Dock = DockStyle.Fill;
-            viewPanel.Controls.Add(viewHost);
-          } else
-            viewPanel.Controls.Add(control);
+          viewPanel.Controls.Add(control);
         }
       } else {
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.cs	(revision 3394)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DockingMainForm.cs	(revision 3395)
@@ -40,7 +40,7 @@
       InitializeComponent();
     }
-    public DockingMainForm(Type userInterfaceItemType, bool showInViewHost)
+    public DockingMainForm(Type userInterfaceItemType, bool showViewsInViewHost)
       : this(userInterfaceItemType) {
-      this.ShowInViewHost = showInViewHost;
+      this.ShowViewsInViewHost = showViewsInViewHost;
     }
 
@@ -69,5 +69,5 @@
       DockForm form;
       IContentView contentView = view as IContentView;
-      if (ShowInViewHost && contentView != null && contentView.GetType() != typeof(ViewHost)) {
+      if (ShowViewsInViewHost && contentView != null && contentView.GetType() != typeof(ViewHost)) {
         ViewHost viewHost = new ViewHost(contentView.Content);
         form = new DockForm(viewHost);
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DocumentForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DocumentForm.cs	(revision 3394)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/DocumentForm.cs	(revision 3395)
@@ -44,14 +44,5 @@
         view.CaptionChanged += new EventHandler(View_CaptionChanged);
         UpdateText();
-
-        ContentView contentView = view as ContentView;
-        if (ViewAttribute.GetShowInViewHost(viewType) && contentView != null) {
-          ViewHost viewHost = new ViewHost();
-          viewHost.ViewType = viewType;
-          viewHost.Content = contentView.Content;
-          viewHost.Dock = DockStyle.Fill;
-          viewPanel.Controls.Add(viewHost);
-        } else
-          viewPanel.Controls.Add(control);
+        viewPanel.Controls.Add(control);
       } else {
         Label errorLabel = new Label();
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainForm.cs	(revision 3394)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MainForm.cs	(revision 3395)
@@ -43,4 +43,5 @@
       this.userInterfaceItems = new List<IUserInterfaceItem>();
       this.initialized = false;
+      this.showViewsInViewHost = false;
     }
 
@@ -51,8 +52,8 @@
 
     #region properties
-    private bool showInViewHost;
-    public bool ShowInViewHost {
-      get { return this.showInViewHost; }
-      set { this.showInViewHost = value; }
+    private bool showViewsInViewHost;
+    public bool ShowViewsInViewHost {
+      get { return this.showViewsInViewHost; }
+      set { this.showViewsInViewHost = value; }
     }
 
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MultipleDocumentMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MultipleDocumentMainForm.cs	(revision 3394)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/MultipleDocumentMainForm.cs	(revision 3395)
@@ -39,7 +39,7 @@
       InitializeComponent();
     }
-    public MultipleDocumentMainForm(Type userInterfaceItemType, bool showInViewHost)
+    public MultipleDocumentMainForm(Type userInterfaceItemType, bool showViewsInViewHost)
       : this(userInterfaceItemType) {
-      this.ShowInViewHost = showInViewHost;
+      this.ShowViewsInViewHost = showViewsInViewHost;
     }
 
@@ -75,5 +75,5 @@
       Form form;
       IContentView contentView = view as IContentView;
-      if (ShowInViewHost && contentView != null && contentView.GetType() != typeof(ViewHost)) {
+      if (ShowViewsInViewHost && contentView != null && contentView.GetType() != typeof(ViewHost)) {
         ViewHost viewHost = new ViewHost(contentView.Content);
         form = new DocumentForm(viewHost);
Index: trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/SingleDocumentMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/SingleDocumentMainForm.cs	(revision 3394)
+++ trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/SingleDocumentMainForm.cs	(revision 3395)
@@ -40,7 +40,7 @@
       InitializeComponent();
     }
-    public SingleDocumentMainForm(Type userInterfaceItemType, bool showInViewHost)
+    public SingleDocumentMainForm(Type userInterfaceItemType, bool showViewsInViewHost)
       : this(userInterfaceItemType) {
-      this.ShowInViewHost = showInViewHost;
+      this.ShowViewsInViewHost = showViewsInViewHost;
     }
 
@@ -69,5 +69,5 @@
       Form form;
       IContentView contentView = view as IContentView;
-      if (ShowInViewHost && contentView != null && contentView.GetType() != typeof(ViewHost)) {
+      if (ShowViewsInViewHost && contentView != null && contentView.GetType() != typeof(ViewHost)) {
         ViewHost viewHost = new ViewHost(contentView.Content);
         form = new DocumentForm(viewHost);
Index: trunk/sources/HeuristicLab.MainForm/3.2/ViewAttribute.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm/3.2/ViewAttribute.cs	(revision 3394)
+++ trunk/sources/HeuristicLab.MainForm/3.2/ViewAttribute.cs	(revision 3395)
@@ -31,5 +31,4 @@
     public ViewAttribute(string name) {
       this.name = name;
-      this.showInViewHost = false;
     }
 
@@ -38,10 +37,4 @@
       get { return this.name; }
       set { this.name = value; }
-    }
-
-    private bool showInViewHost;
-    public bool ShowInViewHost {
-      get { return this.showInViewHost; }
-      set { this.showInViewHost = value; }
     }
 
@@ -57,11 +50,4 @@
       return viewType.Name;
     }
-
-    public static bool GetShowInViewHost(MemberInfo viewType) {
-      ViewAttribute[] attributes = (ViewAttribute[])viewType.GetCustomAttributes(typeof(ViewAttribute), false);
-      if (attributes.Length == 1)
-        return attributes[0].showInViewHost;
-      return false;
-    }
   }
 }
Index: trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs.frame	(revision 3394)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLabOptimizerPlugin.cs.frame	(revision 3395)
@@ -40,5 +40,5 @@
     public override void Run() {
       OptimizerMainForm mainForm = new OptimizerMainForm(typeof(IOptimizerUserInterfaceItemProvider));
-      mainForm.ShowInViewHost = true;
+      mainForm.ShowViewsInViewHost = true;
       Application.Run(mainForm);
     }
Index: trunk/sources/HeuristicLab.Optimizer/3.3/OptimizerMainForm.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimizer/3.3/OptimizerMainForm.cs	(revision 3394)
+++ trunk/sources/HeuristicLab.Optimizer/3.3/OptimizerMainForm.cs	(revision 3395)
@@ -45,7 +45,7 @@
       InitializeComponent();
     }
-    public OptimizerMainForm(Type userInterfaceItemType, bool showInViewHost)
+    public OptimizerMainForm(Type userInterfaceItemType, bool showViewsInViewHost)
       : this(userInterfaceItemType) {
-      this.ShowInViewHost = showInViewHost;
+      this.ShowViewsInViewHost = showViewsInViewHost;
     }
 